Ext.namespace('AeroSQL'); 

AeroSQL.ENGINE_URL = 'engine.php'; 
Ext.BLANK_IMAGE_URL = 'i/extjs-blank.gif'; // '/ext/resources/images/default/s.gif'; // reference local blank image
AeroSQL.NULL_VALUE = '<img style="width: 24px; height: 11px; vertical-align: middle" src="i/null.png" />'

// AeroSQL.debugSQL = 1;


//-------------------------------------------------------------------------------------------

hljs.initHighlightingOnLoad();

// application main entry point
Ext.onReady(function() {
 
    
    Ext.QuickTips.init();
	// Apply a set of config properties to the singleton
    
    Ext.Ajax.extraParams = {
        'debugSQL': 0   // if true, every AJAX response will contain an array of SQL statements: Array $r['debugSQL']
    };

    
	Ext.apply(Ext.QuickTips.getQuickTip(), {
		// maxWidth: 200,
		// minWidth: 100,
		showDelay: 1500
		// trackMouse: true
	});

	var pnWnd = new Ext.TabPanel({
		region: 'center',
		// xtype: 'tabpanel',
		items: [{
			title: 'Dashboard',
			xtype: 'panel'
		}]
		// , layoutOnTabChange: true
	});
	
    AeroSQL.mainTabPanel = pnWnd;
    
	var pnInfo = new Ext.Panel({
		region: 'south',
        height: 160,
        collapsible: true,
		split: true,
        bodyStyle: 'background-color: #eee;',
        autoScroll: true,
        title: 'Info',
        iconCls: ''
        // titleCollapse: true
    });
    
    var dbTree = new AeroSQL.DBTree ({
		region: 'center',
		title: '',
		// xtype: 'meDBTree',
		width: 250,
		autoScroll: true,
		split: true,
		pnWnd: pnWnd,      // where to open tabsheets
        pnInfo: pnInfo     // where to display additional node info
	});
    
    var pnLeft = new Ext.Panel({
        region: 'west',
        collapsible: true,
        collapseMode: 'mini',
		split: true,
        animate: false,        
        border: false,
        width: 250,
        layout: 'border',
        items: [dbTree, pnInfo]
    });
 
    var vp = new Ext.Viewport({
	    layout: 'border',
	    items: [
		{
	        region: 'north',
	        xtype: 'toolbar',
			items: [{
				text: 'Server',
				menu: {
					items: [{text: 'Process List', disabled: true}, 
                            '-', 
                            {text: 'System Variables', disabled: true}, {text: 'Status Variables', disabled: true}, 
                            '-', 
                            {text: 'Flush...', disabled: true},
                            '-', 
                            {text: 'Exit', hidden: true, handler: function() { window.close(); }, scope: this }
                    ]
				}
			}, {
				text: 'Database',
				menu: {
					items: [{text: 'Create Database...', disabled: true}, {text: 'Drop Database', disabled: true}]
				}
			}, {
				text: 'Table',
				menu: {
					items: [
                            {text: 'Edit Data', iconCls: 'icon icon-tbl_edit', handler: dbTree.onTblEdit, scope: dbTree},
                            '-',
                            {text: 'Manage Columns', iconCls: 'icon-col_man', disabled: true}, 
                            {text: 'Manage Indexes', iconCls: 'icon-idx_man', disabled: true}
                           ]
				}
			}, 
            '-',
            {
                text: 'Tools',
                menu: {
                    items: [{text: 'SQL Monitor', iconCls: 'icon-terminal', handler: SqlMonitorClick, scope: this}]
                }
            },
			'->',
            {text: 'About', iconCls: 'icon-info', handler: function() { var t = new AeroSQL.About(); t.show(); }, scope: this},
			{text: 'Homepage', iconCls: 'icon-globe', handler: function(){ window.open('http://www.burlaca.com/aerosql/','homepage');} }
			]
			// autoHeight: true,
	        //border: false,
	        //margins: '0 0 5 0'
		},        
		pnLeft,
		pnWnd
	/**    , {
	        region: 'south',
	        title: 'Information',
	        collapsible: true,
	        html: '',
	        split: true,
	        height: 100,
	        minHeight: 100
	    }
	*/
	    ]
	});
	
    AeroSQL.logSql = function(items) {
        var pn = Ext.getCmp('pnSqlMonitor');
        if (!pn) {return;}
        
        pn.log(items);
    }
    
    setTimeout(function(){
        Ext.get('loading').remove();
        Ext.fly('loading-mask').fadeOut({
			remove:true,
			callback : function() {
                /*
				var cp = new Ext.state.CookieProvider();

				if(window.console && window.console.firebug && ! cp.get('hideFBWarning')){
					var tpl = new Ext.Template(
						'<div style="border: 1px solid #FF0000; background-color:#FFAAAA; display:none; padding:15px; color:#000000;"><b>Warning: </b> Firebug is known to cause performance issues with Ext JS. <a href="#" id="hideWarning">[ Hide ]</a></div>'			   
					);
					var newEl = tpl.insertFirst('all-demos');
					
					Ext.fly('hideWarning').on('click', function() {
						Ext.fly(newEl).slideOut('t',{remove:true});
						cp.set('hideFBWarning', true);	
					});
					Ext.fly(newEl).slideIn();
				}
				
            */				
			}
		
		});
    }, 250);

});  
//------------------------------------------------------------------------------------------------------------------------------------------------
function SqlMonitorClick() {
    var tpMain = AeroSQL.mainTabPanel;
    var pn = Ext.getCmp('pnSqlMonitor');
    if (pn) {
        tpMain.setActiveTab(pn);
    } else {
        pn = new AeroSQL.Monitor({id: 'pnSqlMonitor'});
        tpMain.add(pn);
        tpMain.setActiveTab(pn);
        tpMain.doLayout();
    }
}
//------------------------------------------------------------------------------------------------------------------------------------------------